# Copyright (C) 2007, Red Hat, Inc, and Owen Williams
#
# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public
# License along with this library; if not, write to the
# Free Software Foundation, Inc., 59 Temple Place - Suite 330,
# Boston, MA 02111-1307, USA.

import os
import sys
import signal

import pygtk
pygtk.require('2.0')

import gtk
import gobject
import time
import logging

from sugar.activity import activity

activity_root = activity.get_bundle_path()
os.chdir(activity_root)

class ClassicGnome(activity.Activity):
	DISPLAY = ":299"

	def __init__(self, handle):
		activity.Activity.__init__(self, handle)
		self.set_title("Classic Gnome")

		self.connect('destroy', self._destroy_cb)

		self._xephyr_pid = None
		self._nautilus_pid = None
		self._wm_pid = None
                self._gvm_pid = None

                # remove any children of the window that Sugar may have added
                for widget in self.window.get_children():
                    self.window.remove(widget)

		#drawing_area = gtk.DrawingArea()
		#self.add(drawing_area)
		#drawing_area.show()

		gobject.idle_add(self._start_xephyr, self.window.xid)

	def _start_xephyr(self, xid):
		try:
			pid = os.fork()
			if pid == 0:
				os.execlp('/usr/bin/Xephyr', '/usr/bin/Xephyr', self.DISPLAY,
						  '-ac','-parent', '%d' % xid, '-dpi', '150')
				sys.exit(1)
		except OSError, e:
			sys.exit(1)
		self._xephyr_pid = pid
		time.sleep(0.5)

		try:
			pid = os.fork()
			if pid == 0:
				os.environ['DISPLAY'] = self.DISPLAY
				os.execlp('/usr/bin/metacity', '/usr/bin/metacity')
				sys.exit(1)
		except OSError, e:
			sys.exit(1)
		self._wm_pid = pid

		try:
			pid = os.fork()
			if pid == 0:
				os.environ['DISPLAY'] = self.DISPLAY
				os.execlp('/usr/bin/nautilus', '/usr/bin/nautilus')
				sys.exit(1)
		except OSError, e:
			sys.exit(1)
		self._nautilus_pid = pid

                try:
			pid = os.fork()
			if pid == 0:
				os.environ['DISPLAY'] = self.DISPLAY
				os.execlp('/usr/bin/gnome-volume-manager', '/usr/bin/gnome-volume-manager')
				sys.exit(1)
		except OSError, e:
			sys.exit(1)
		self._gvm_pid = pid


	def _destroy_cb(self, window):
		os.kill(self._nautilus_pid, signal.SIGKILL)
		os.kill(self._wm_pid, signal.SIGKILL)
		os.kill(self._xephyr_pid, signal.SIGKILL)
                os.kill(self._gvm_pid, signal.SIGKILL)
